%define	name			mesa
%define version			7.0.2
%define subrel 1
%define release			%mkrel 6

%define eglname			mesaegl
%define glname			mesagl
%define gluname			mesaglu
%define glutname		mesaglut
%define glwname			mesaglw
%define eglmajor		1
%define glmajor			1
%define glumajor		1
%define glutmajor		3
%define glwmajor		1
%define libeglname              %mklibname %{eglname} %{eglmajor}
%define libglname		%mklibname %{glname} %{glmajor}
%define libgluname		%mklibname %{gluname} %{glumajor}
%define libglutname		%mklibname %{glutname} %{glutmajor}
%define libglwname		%mklibname %{glwname} %{glwmajor}

%define oldlibglname		%mklibname MesaGL 1
%define oldlibgluname		%mklibname MesaGLU 1
%define oldlibglutname		%mklibname Mesaglut 3

%define mesasrcdir		%{_prefix}/src/Mesa/
%define driver_dir		%{_libdir}/dri

%define enable_egl		0

#FIXME: (for 386/485) unset SSE, MMX and 3dnow flags
#FIXME: (for >=i586)  disable sse
#       SSE seems to have problem on some apps (gtulpas) for probing.
%define	dri_drivers_i386	"i810 i915tex i915 i965 mga mach64 r128 r200 r300 radeon savage sis unichrome tdfx"

%define	dri_drivers_x86_64	"i810 i915tex i915 i965 mga mach64 r128 r200 r300 radeon savage sis unichrome tdfx"
%define	dri_drivers_ppc		"mach64 r128 r200 r300 radeon tdfx"
%define	dri_drivers_ppc64	""
%define	dri_drivers_ia64	"i810 i915 i965 mga r128 r200 radeon"
%define	dri_drivers_alpha	"mga r128 r200 radeon"
%define	dri_drivers_sparc	"ffb mach64 mga radeon savage"
%define	dri_drivers		%{expand:%{dri_drivers_%{_arch}}}

Name:		%{name}
Version: 	%{version}
Release: 	%{release}
Summary:	OpenGL 2.1 compatible 3D graphics library
Group:		System/Libraries

BuildRequires:	tcl
BuildRequires:	texinfo
BuildRequires:	libxfixes-devel		>= 4.0.3
BuildRequires:	libxt-devel		>= 1.0.5
BuildRequires:	libxmu-devel		>= 1.0.3
BuildRequires:	libx11-devel		>= 1.1.3
BuildRequires:	libxdamage-devel	>= 1.1.1
BuildRequires:	libexpat-devel		>= 2.0.1
BuildRequires:	makedepend
BuildRequires:	x11-proto-devel		>= 7.3
BuildRequires:	libdrm-devel		>= 2.3.0

BuildRequires:	libxext-devel		>= 1.0.3
BuildRequires:	libxxf86vm-devel	>= 1.0.1
BuildRequires:	libxi-devel		>= 1.1.3
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://www.mesa3d.org
Source0:	http://prdownloads.sourceforge.net/mesa3d/MesaLib-%{version}.tar.bz2
Source1:	http://prdownloads.sourceforge.net/mesa3d/MesaDemos-%{version}.tar.bz2
Source2:	http://prdownloads.sourceforge.net/mesa3d/MesaGLUT-%{version}.tar.bz2
Source3:	mesa-source-file-generator
Source4:	Mesa-icons.tar.bz2
Source5:	mesa-driver-install
Source6:	gl_API.xml
Source7:	EXT_framebuffer_object.xml

# git format-patch mesa_7_0_2..origin/mesa_7_0_branch
Patch1:   0001-add-glw.pc.in-to-tarball-list-remove-from-DEPEND_FI.patch
Patch2:   0002-remove-dependency-on-libGLU.patch
Patch3:   0003-DRI-memory-manager-info-fixes-dangling-link.patch
Patch4:   0004-add-pointer-to-Gallium3D-info.patch
Patch5:   0005-fix-bogus-assumption-if-ddx-has-set-up-surface-reg-f.patch
Patch6:   0006-fix-position-invariant-vertex-programs-for-sw-tnl.patch
Patch7:   0007-added-gl_dispatch_stub_772.patch
Patch8:   0008-fix-out-of-bounds-array-index-ix-1.patch
Patch9:   0009-fix-some-texture-format-assertions-etc.patch
Patch10:  0010-clamp-lambda-to-Min-MaxLod.patch
Patch11:  0011-Rename-glut_fbc.c-glut_fcb.c-cb-callback.patch
Patch12:  0012-Obsolete.patch
Patch13:  0013-bring-over-Fortran-fixes-from-master.patch
Patch14:  0014-Initial-7.0.3-relnotes.patch
Patch15:  0015-fix-z-buffer-read-write-issue-with-rv100-like-chips.patch
Patch16:  0016-Recompute-ctx-Point._Size-if-GL_POINT_SIZE_MIN-MAX.patch
Patch17:  0017-Bump-version-numbers-to-7.0.3-for-next-release.patch
Patch18:  0018-need-to-check-border-width-in-sample_linear_2d-f.patch
Patch19:  0019-Fix-parsing-of-gl_FrontLightModelProduct.sceneColor.patch
Patch20:  0020-fix-a-few-GLSL-bugs.patch
Patch21:  0021-Consolidate-texture-fetch-code-and-use-partial-deriv.patch
Patch22:  0022-i915tex-Actually-wait-for-previous-commands-to-comp.patch
Patch23:  0023-i915tex-Some-additional-blit-fixes-and-assertions.patch
Patch24:  0024-i915tex-Catch-cases-where-not-all-state-is-emitted.patch
Patch25:  0025-i915tex-Fix-some-minor-batchbuffer-errors.patch
Patch26:  0026-improve-24-bit-Z-to-32-bit-Z-conversion.patch
Patch27:  0027-set-fp-UsesKill-when-emitting-OPCODE_KIL.patch
Patch28:  0028-document-GLSL-float-f-F-suffix-bug.patch
Patch29:  0029-minor-additions-to-avoid-FAQs.patch
Patch30:  0030-use-DEFAULT_SOFTWARE_DEPTH_BITS.patch
Patch31:  0031-r200-Fix-texture-format-regression-on-big-endian-sy.patch
Patch32:  0032-make-sure-state-token-values-are-fully-initialized.patch
Patch33:  0033-Move-_mesa_load_tracked_matrices-from-TNL-module-t.patch
Patch34:  0034-cleanups-comments.patch
Patch35:  0035-New-ctx-Driver.Map-UnmapTexture-functions-for-acc.patch
Patch36:  0036-i965-use-uncompressed-instruction-to-ensure-only.patch
#Patch37:  0037-better-front-plane-clip-test.patch
Patch38:  0038-fix-broken-two-sided-stencil.patch
Patch39:  0039-fix-build-remove-ctx-_Facing-assignment.patch
Patch40:  0040-i915tex-Fix-up-state-changes-for-i8xx.patch
Patch41:  0041-added-missing-quote-char.patch
Patch42:  0042-fix-two-sided-stencil.patch
#Patch43:  0043-Fix-the-library-name-in-glw.pc.patch
Patch44:  0044-fix-DD_TRI_LIGHT_TWOSIDE-bug-13368.patch
Patch45:  0045-fix-two-side-lighting-bug-crash.patch
Patch46:  0046-Use-Bsymbolic-for-linking-all-shared-objects.patch
Patch47:  0047-Fix-gl_FrontFacing-compilation-problem.patch
Patch48:  0048-fix-span-facing-computation-and-gl_FrontFacing-init.patch
Patch49:  0049-fix-gl_FrontFacing.patch
Patch50:  0050-configs-Fix-linking-with-static-libGL-and-as-need.patch
Patch51:  0051-fix-polygon-cull-regression.patch
Patch52:  0052-i915tex-Fix-issues-with-glDrawBuffer-GL_NONE.patch
Patch53:  0053-fix-NEED_SECONDARY_COLOR-for-vert-frag-progs.patch
Patch54:  0054-simplify-update-two-side-lighting-test-follow-on-to.patch
Patch55:  0055-Remove-I-TOP-src-mesa-transform.patch
Patch56:  0056-i965-restore-the-flag-after-building-the-subroutine.patch
Patch57:  0057-i965-allocate-GRF-registers-before-building-subrout.patch
Patch58:  0058-return-correct-size-from-glGetActiveUniform-bug-137.patch
Patch59:  0059-glGetActiveUniform-fix.patch
Patch60:  0060-fix-GL_LINE_LOOP-with-drivers-using-own-render-pipel.patch
Patch61:  0061-add-missing-double-quote-bug-13878.patch
Patch62:  0062-add-Get-info-for-MAX_3D_TEXTURE_SIZE-for-bug-1381.patch
Patch63:  0063-added-get-info-for-framebuffer-object-tokens.patch
Patch64:  0064-Fix-several-bugs-relating-to-uniforms-and-attributes.patch
Patch65:  0065-More-fixes-to-shader_api.patch
Patch66:  0066-Add-a-test-program-to-test-for-assorted-bugs-in-shad.patch
Patch67:  0067-Make-use-of-count-in-_mesa_uniform_matrix.patch
#Patch68:  0068-Convert-to-0-1-when-setting-boolean-uniforms.patch
Patch69:  0069-fix-GLSL-uniform-attrib-bugs-13753.patch
Patch70:  0070-additional-GL_COLOR_ATTACHMENTx_EXT-cases-bug-13767.patch
Patch71:  0071-fix-vbo-display-list-memleak-upon-context-destructio.patch
Patch72:  0072-additional-GL_COLOR_ATTACHMENTx_EXT-cases-bug-13767.patch
Patch73:  0073-additional-stub-functions.patch
Patch75:  0075-fix-3d-proxy-texture-depth-bug.patch
Patch74:  0074-fix-depth-1-typo-in-glTexImage3D-proxy-code.patch
Patch76:  0076-i915tex-Centralize-mipmap-pitch-computations.patch
Patch77:  0077-i965-Fix-unresolved-symbol-intel_miptree_pitch_alig.patch
Patch78:  0078-i965-Fix-byte-vs.-pixel-unit-mixup-for-aligned-text.patch
Patch79:  0079-prep-for-7.0.3-release.patch
Patch80:  0080-define-M_PI-if-needed.patch
Patch81:  0081-remove-unused-var.patch
Patch82:  0082-Don-t-build-yuvrect_client-by-default.patch
Patch83:  0083-fix-pc-vs.-gc-ps-usage-bug-14197.patch
Patch84:  0084-fix-GLX-vertex-array-bug-14197.patch
Patch85:  0085-glxinfo-Fix-multisample-visual-reporting.patch
#Patch86:  0086-Assorted-patches-for-miniglx-linux-solo-Gavin-Li-c.patch
Patch87:  0087-i965-re-define-the-type-of-reg.loopcount.patch
Patch88:  0088-i965-valid-message-length-includes-message-header.patch
Patch89:  0089-fix-some-pbo-path-problems.patch
Patch90:  0090-pull-some-more-fixes-for-pbo-access-from-trunk.patch
Patch91:  0091-R300-RV410-SE-chips-have-half-the-pipes-of-regular.patch
Patch92:  0092-Add-new-RV380-pci-id.patch
Patch93:  0093-check-if-fb-Delete-is-null-bugs-13507-14293.patch
Patch94:  0094-fix-bugs-13507-14293.patch
Patch95:  0095-fix-w-component-of-glsl-vec4-asin.patch
Patch96:  0096-regenerate-glsl-library-functions.patch
Patch97:  0097-965-Fix-memory-leak-when-deleting-buffers-with-bac.patch
Patch98:  0098-Fix-bug-9871-enable-user-defined-clip-planes-for-R3.patch
Patch99:  0099-fix-bug-9871.patch
Patch100: 0100-added-altopts-to-allow-overriding-all-other-opts.patch
Patch101: 0101-_mesa_swizzle_ubyt_image-Don-t-use-single-swizzle_c.patch
Patch103: 0103-fix-bug-with-generated-fragment-programs-if-vertex-s.patch
Patch104: 0104-Fix-glBindTexture-crash-bug-14514.patch
Patch105: 0105-Fix-potential-glDrawPixels-GL_DEPTH_COMPONENT-crash.patch
Patch106: 0106-i965-new-integrated-graphics-chipset-support.patch
Patch107: 0107-Apple-Pulled-in-changes-from-Apple-s-patchset-to-al.patch
Patch108: 0108-Added-size-name-Get-mode-get-lines-for-point.patch
Patch109: 0109-Fix-glBegin-time-test-for-invalid-programs-shaders.patch
Patch110: 0110-raise-GL_INVALID_OPERATION-if-glProgramString-compil.patch
Patch111: 0111-Fix-point-rasterization-regression-caused-by-commit.patch
Patch112: 0112-latest-bug-fixes.patch
Patch113: 0113-prep-for-7.0.3-rc-2.patch
Patch114: 0114-bump-libGL.so-version-number.patch
Patch115: 0115-Replace-glut_fbc.c-with-glut_fcb.c-cb-callback.patch
Patch116: 0116-Don-t-Swap-buffer-if-a-DRIDrawable-is-entirely-obscu.patch
Patch117: 0117-state.depth.range-alpha-value-should-be-1-not-0-bu.patch
Patch118: 0118-fix-__builtin_expect-definition-test-for-IBM-XLC.patch
Patch119: 0119-init-vertex-weight-attrib-to-1-0-0-0.patch
Patch120: 0120-Set-normalized-flag-for-GLubyte-arrays-in-_mesa_Vert.patch
Patch121: 0121-fix-parsing-of-state.texenv.color-bug-14931.patch

# DRI modules are not under /usr/X11R6 anymore
Patch1000:	mesa-6.5.1-default_dri_dir.patch
# Install EGL header files and fixes other minor compilations problems when enabling EGL
Patch1001:	mesa-egl_support.patch
# Fix linux-dri so it can be used for all archs (thanks Christiaan Welvaart)
Patch1002:	Mesa-7.0-linux-dri-config.patch
# remove unfinished GLX_ARB_render_texture
Patch1003:	mesa-6.5.2-no-ARB_render_texture.patch
# reported as upstream bug 12097
Patch1004:	mesa-7.0.1-via_null_deref2.patch
# (tv) fix build:
Patch1005:	mesa-7.0.2-build-config.patch 
# Fixes: 3D rendering problems on intel 965 video cards
# https://qa.mandriva.com/show_bug.cgi?id=39861
Patch1006:	mesa-7.0.2-rc3-i965-brw-reversed-logic.patch

License:	MIT
Requires:	%{libglname} = %{version}-%{release}
Provides:	hackMesa = %{version}
Obsoletes:	hackMesa <= %{version}
Provides:	Mesa = %{version}
Obsoletes:	Mesa < %{version}

%package	source
Summary:	Source files required for the Xorg 7.0 to enable glx support
Group:		Development/C
Requires:	%{libglname}-devel >= %{version}

%if %{enable_egl}
%package -n	%{libeglname}
Summary:	Files for Mesa (EGL libs)
Group:		System/Libraries

%package -n	%{libeglname}-devel
Summary:	Development files for Mesa (EGL libs)
Group:		Development/C
Requires:	%{name} = %{version}
Provides:	EGL-devel
%endif

%package -n	%{libglname}
Summary:	Files for Mesa (GL and GLX libs)
Group:		System/Libraries
Obsoletes:	%{oldlibglname} < 6.4 
Provides:	%{oldlibglname} = %{version}-%{release}
# (anssi) Forces the upgrade of x11-server-common to happen before
# alternatives removal, which allows x11-server-common to grab the symlink.
Conflicts:	x11-server-common < 1.3.0.0-17

%package -n	%{libglname}-devel
Summary:	Development files for Mesa (OpenGL compatible 3D lib)
Group:		Development/C
Requires:	%{name} = %{version}
Provides:	lib%{glname}-devel = %{version}-%{release}
Provides:	%{glname}-devel = %{version}-%{release}
Provides:	GL-devel
Obsoletes:	%{oldlibglname}-devel < 6.4
Provides:	%{oldlibglname}-devel = %{version}-%{release}
Provides:	libMesaGL-devel = %{version}-%{release}
Provides:	MesaGL-devel = %{version}-%{release}

%package -n	%{libgluname}
Summary:	Files for Mesa (GLU libs)
Group:		System/Libraries
Obsoletes:	%{oldlibgluname} < 6.4
Provides:	%{oldlibgluname} = %{version}-%{release}

%package -n	%{libgluname}-devel
Summary:	Development files for GLU libs
Group:		Development/C
Requires:	%{libgluname} = %{version}-%{release}
Provides:	lib%{gluname}-devel = %{version}-%{release}
Provides:	%{gluname}-devel = %{version}-%{release}
Obsoletes:	%{oldlibgluname}-devel < 6.4
Provides:	%{oldlibgluname}-devel = %{version}-%{release}
Provides:	libMesaGLU-devel = %{version}-%{release}
Provides:	MesaGLU-devel = %{version}-%{release} 

%package -n	%{libglutname}
Summary:	Files for Mesa (glut libs)
Group:		System/Libraries
Requires:	%{libgluname} = %{version}-%{release}
Provides:	Mesa-common = %{version}-%{release} hackMesa-common = %{version}
Obsoletes:	Mesa-common <= %{version} hackMesa-common <= %{version}
Obsoletes:	%{oldlibglutname} < 6.4
Provides:	%{oldlibglutname} = %{version}-%{release}

%package -n	%{libglutname}-devel
Summary:	Development files for glut libs
Group:		Development/C
Requires:	%{libglutname} = %{version}-%{release} %{libgluname}-devel = %{version}-%{release}
Provides:	lib%{glutname}-devel = %{version}-%{release} 
Provides:	%{glutname}-devel = %{version}-%{release} 
Obsoletes:	%{oldlibglutname}-devel < 6.4
Provides:	%{oldlibglutname}-devel = %{version}-%{release}
Provides:	libMesaGLUT-devel = %{version}-%{release}
Provides:	MesaGLUT-devel = %{version}-%{release}

%package -n	%{libglwname}
Summary:	Files for Mesa (glw libs)
Group:		System/Libraries
Provides:	Mesa-common = %{version}-%{release} hackMesa-common = %{version}
Obsoletes:	Mesa-common <= %{version} hackMesa-common <= %{version}

%package -n	%{libglwname}-devel
Summary:	Development files for glw libs
Group:		Development/C
Requires:	%{libglwname} = %{version}-%{release}
Provides:	lib%{glwname}-devel = %{version}-%{release} 
Provides:	%{glwname}-devel = %{version}-%{release} 

%package	common-devel
Summary:	Meta package for mesa devel
Group:		Development/C
Provides:	Mesa-common-devel = %{version}-%{release} 
Provides:	hackMesa-common-devel = %{version}
Obsoletes:	Mesa-common-devel < %{version} 
Obsoletes:	hackMesa-common-devel < %{version}
Requires:	%{libglname}-devel = %{version}
Requires:	%{libglwname}-devel = %{version}
Requires:	%{libgluname}-devel = %{version}
Requires:	%{libglutname}-devel = %{version}

%package	demos
Summary:	Demos for Mesa (OpenGL compatible 3D lib)
Group:		Graphics
Requires:	%{name} >= %{version}
Provides:	hackMesa-demos = %{version}
Obsoletes:	hackMesa-demos <= %{version}
Obsoletes: 	Mesa-demos < 6.4
Provides:	Mesa-demos = %{version}-%{release}

%description
Mesa is an OpenGL 2.1 compatible 3D graphics library.

%description	source
Mesa is an OpenGL 2.1 compatible 3D graphics library.

Source files required by the Xorg to enable glx support.

%description common-devel
Mesa common metapackage devel

%if %{enable_egl}
%description -n	%{libeglname}
Mesa is an OpenGL 2.1 compatible 3D graphics library.
EGL parts.

%description -n	%{libeglname}-devel
Mesa is an OpenGL 2.1 compatible 3D graphics library.
EGL development parts.
%endif

%description -n	%{libglname}
Mesa is an OpenGL 2.1 compatible 3D graphics library.
GL and GLX parts.

%description -n	%{libglname}-devel
Mesa is an OpenGL 2.1 compatible 3D graphics library.

This package contains the headers needed to compile Mesa programs.

%description -n	%{libgluname}
GLU is the OpenGL Utility Library.
It provides a number of functions upon the base OpenGL library to provide
higher-level drawing routines from the more primitive routines provided by
OpenGL.

%description -n	%{libgluname}-devel
This package contains the headers needed to compile programs with GLU.

%description -n	%{libglutname}
GLUT (OpenGL Utility Toolkit) is a addon library for OpenGL programs. It
provides them utilities to define and control windows, input from the keyboard
and the mouse, drawing some geometric primitives (cubes, spheres, ...).
GLUT can even create pop-up windows.

%description -n	%{libglutname}-devel
Mesa is an OpenGL 2.1 compatible 3D graphics library.
glut parts.

This package contains the headers needed to compile Mesa programs.

%description -n	%{libglwname}
GLw adds Motif bindings to the OpenGL "canvas" (Xt/Motif/OpenGL widget code).

%description -n	%{libglwname}-devel
Mesa is an OpenGL 2.1 compatible 3D graphics library.
GLw parts.

This package contains the headers needed to compile Mesa programs.

%description	demos
Mesa is an OpenGL 2.1 compatible 3D graphics library.

This package contains some demo programs for the Mesa library.

%prep
%setup -q -n Mesa-%{version} -b1 -b2

cp -f %{SOURCE6} %{SOURCE7} src/mesa/glapi

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
#%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
#%patch43 -p1
%patch44 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1
%patch48 -p1
%patch49 -p1
%patch50 -p1
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p1
%patch55 -p1
%patch56 -p1
%patch57 -p1
%patch58 -p1
%patch59 -p1
%patch60 -p1
%patch61 -p1
%patch62 -p1
%patch63 -p1
%patch64 -p1
%patch65 -p1
%patch67 -p1
#%patch68 -p1
%patch69 -p1
%patch70 -p1
%patch71 -p1
%patch72 -p1
%patch73 -p1
%patch74 -p1
%patch75 -p1
%patch76 -p1
%patch77 -p1
%patch78 -p1
%patch79 -p1
%patch80 -p1
%patch81 -p1
%patch82 -p1
%patch83 -p1
%patch84 -p1
%patch85 -p1
#%patch86 -p1
%patch87 -p1
%patch88 -p1
%patch89 -p1
%patch90 -p1
%patch91 -p1
%patch92 -p1
%patch93 -p1
%patch94 -p1
%patch95 -p1
%patch96 -p1
%patch97 -p1
%patch98 -p1
%patch99 -p1
%patch100 -p1
%patch101 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1

%patch1003 -p1 -b .no-ARB_render_texture
%patch1000 -p1 -b .default_dri_dir

%if %{enable_egl}
%patch1001 -p1 -b .egl_support
%endif

%patch1002 -p1 -b .linux-dri-config
%patch1004 -p1 -b .via_null_deref2
%patch1005 -p1 -b .fix_build
%patch1006 -p1 -b .brw-reversed-logic

pushd progs/demos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{_libdir}/mesa-demos-data/|" $i ; 
	done 
	perl -pi -e "s|isosurf.dat|%{_libdir}/mesa-demos-data/isosurf.dat|" isosurf.c 
} && popd
pushd progs/xdemos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{_libdir}/mesa-demos-data/|" $i ; 
	done 
} && popd

chmod +x %{SOURCE5}

%build
LIB_DIR=%{_lib}
INCLUDE_DIR=$RPM_BUILD_ROOT%{_includedir}
DRI_DRIVER_DIR="%{driver_dir}"
export LIB_DIR INCLUDE_DIR DRI_DRIVER_DIR

# (blino) strict aliasing is known to break some Mesa code
#   https://bugs.freedesktop.org/show_bug.cgi?id=6046
#   https://bugs.freedesktop.org/show_bug.cgi?id=9456
# (blino) tree VRP in gcc-4.2.1 triggers misrendering in Blender,
#         and hard lock with compiz (in r300_state.c)
#   https://bugs.freedesktop.org/show_bug.cgi?id=11380
#   http://gcc.gnu.org/bugzilla/show_bug.cgi?id=32544
# (tv) -O1 fixe some freeze on r200 (http://bugs.freedesktop.org/show_bug.cgi?id=10224)
ARCH_FLAGS="$RPM_OPT_FLAGS -O1 -fno-strict-aliasing -fno-tree-vrp -DNDEBUG -DDEFAULT_DRIVER_DIR=\\\"%{driver_dir}\\\""
export ARCH_FLAGS

%make 	MKDEP=/usr/bin/makedepend \
	USING_EGL=%{enable_egl} \
	DRI_DIRS=%{dri_drivers} \
	DRI_DRIVER_SEARCH_DIR=%{driver_dir} \
	LIB_DIR=$LIB_DIR \
	linux-dri

pushd progs/demos
%make LIB_DIR=$LIB_DIR
popd
pushd progs/xdemos
%make LIB_DIR=$LIB_DIR
popd

%install
LIB_DIR=%{_lib}
INCLUDE_DIR=$RPM_BUILD_ROOT%{_includedir}
DRI_DRIVER_DIR="%{_libdir}/dri"
export LIB_DIR INCLUDE_DIR DRI_DRIVER_DIR DRIMODULE_SRCDIR DRIMODULE_DESTDIR

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa-demos-data
mkdir -p $RPM_BUILD_ROOT%{_includedir}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
make INSTALL_DIR=/$RPM_BUILD_ROOT%{_prefix} \
     DRI_DRIVER_INSTALL_DIR=$RPM_BUILD_ROOT$DRI_DRIVER_DIR \
     MKDEP=%{_bindir}/makedepend \
     USING_EGL=%{enable_egl} \
     DRI_DIRS=%{dri_drivers} \
     LIB_DIR=$LIB_DIR \
     install

mkdir -p %{buildroot}/%{_bindir}
for demo in `find progs/demos -type f -perm /a+x` `find progs/xdemos -type f -perm /a+x`; do
    cp -v $demo %{buildroot}/%{_bindir}
done
# (fg) So that demos at least work :)
cp -v progs/images/*rgb progs/demos/isosurf.dat %{buildroot}/%{_libdir}/mesa-demos-data


# (blino) hardlink libGL files in %{_libdir}/mesa
# to prevent proprietary driver installers from removing them
mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa
pushd $RPM_BUILD_ROOT%{_libdir}/mesa
for l in ../libGL.so.*; do cp -a $l .; done
popd

# icons for three demos examples [we lack a frontend
# to launch the demos obviously]
install -m 755 -d $RPM_BUILD_ROOT%{_miconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_iconsdir}
install -m 755 -d $RPM_BUILD_ROOT%{_liconsdir}
tar jxvf %{SOURCE4} -C $RPM_BUILD_ROOT%{_iconsdir}

# clean any .la file with still reference to tmppath.
perl -pi -e "s|\S+$RPM_BUILD_DIR\S*||g" $RPM_BUILD_ROOT/%{_libdir}/*.la

# generate mesa source files
chmod +x %{SOURCE3}
%{SOURCE3} $RPM_BUILD_ROOT %{mesasrcdir}


%clean
rm -fr $RPM_BUILD_ROOT

%if %{enable_egl}
%post -n %{libeglname} -p /sbin/ldconfig
%postun -n %{libeglname} -p /sbin/ldconfig
%endif

%post -n %{libglname} -p /sbin/ldconfig

%postun -n %{libglname} -p /sbin/ldconfig

%post -n %{libgluname} -p /sbin/ldconfig 

%postun -n %{libgluname} -p /sbin/ldconfig

%post -n %{libglutname} -p /sbin/ldconfig 

%postun -n %{libglutname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc docs/COPYING docs/README.*

%files source -f mesa-source-rpm-filelist.lst
%defattr(-,root,root)
%doc docs/COPYING

%if %{enable_egl}
%files -n %{libeglname}
%defattr(-,root,root)
%{_libdir}/libegl.so.1*
%{_libdir}/libegldri.so.1*

%files -n %{libeglname}-devel
%defattr(-,root,root)
%{_libdir}/libegl.so
%{_libdir}/libegldri.so
%{_includedir}/gles/egl*.h
%endif

%files -n %{libglname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libGL.so.*
%dir %{_libdir}/mesa
%{_libdir}/mesa/libGL.so.*
%ifnarch ppc64
%dir %{_libdir}/dri
%{_libdir}/dri/*
%endif
%ifarch %{ix86}
#%{_libdir}/modules/*
%endif

%files -n %{libglname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/gl.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/osmesa.h
%ifnarch ia64 alpha
%{_includedir}/GL/svgamesa.h
%endif
%{_includedir}/GL/glx.h
%{_includedir}/GL/glxext.h
%{_includedir}/GL/glx_mangle.h
%{_includedir}/GL/xmesa.h
%{_includedir}/GL/xmesa_x.h
%{_includedir}/GL/xmesa_xf86.h
%{_libdir}/libGL.so
%_libdir/pkgconfig/*.pc

#FIXME: check those headers
%{_includedir}/GL/mglmesa.h
%{_includedir}/GL/amesa.h
%{_includedir}/GL/dmesa.h
%{_includedir}/GL/fxmesa.h
%{_includedir}/GL/ggimesa.h
%{_includedir}/GL/glfbdev.h
%{_includedir}/GL/uglglutshapes.h
%{_includedir}/GL/uglmesa.h
%{_includedir}/GL/vms_x_fix.h
%{_includedir}/GL/wmesa.h

%files -n %{libgluname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libGLU.so.*

%files -n %{libglutname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libglut.so.*

%files -n %{libglwname}
%defattr(-,root,root)
%doc docs/COPYING
%{_libdir}/libGLw.so.*


%files -n %{libgluname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/glu.h
%{_includedir}/GL/glu_mangle.h
%{_includedir}/GL/mesa_wgl.h
%{_libdir}/libGLU.so

%files -n %{libglutname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/glut.h
%{_includedir}/GL/glutf90.h
%{_libdir}/libglut.so

%files common-devel
%defattr(-,root,root)

%files -n %{libglwname}-devel
%defattr(-,root,root)
%doc docs/COPYING
%{_includedir}/GL/GLwDrawA.h
%{_includedir}/GL/GLwDrawAP.h
%{_includedir}/GL/GLwMDrawA.h
%{_includedir}/GL/GLwMDrawAP.h
%{_libdir}/libGLw.so

%files demos
%defattr(-,root,root)
%doc docs/COPYING
%{_bindir}/*
%dir %{_libdir}/mesa-demos-data
%{_libdir}/mesa-demos-data/*
%{_miconsdir}/*demos*.png
%{_iconsdir}/*demos*.png
%{_liconsdir}/*demos*.png



%changelog
* Wed Apr 30 2008 Vincent Danen <vdanen@mandriva.com> 7.0.2-6.1mdv2008.1
- build for updates

* Wed Apr 23 2008 Paulo Andrade <pcpa@mandriva.com.br> 7.0.2-6mdv2008.1
+ Revision: 196956
- Correct problem of reversed logic in Mesa-7.0.3 rc3 on intel i965 cards.
  See https://qa.mandriva.com/show_bug.cgi?id=39861 for more details.

* Mon Mar 10 2008 Paulo Andrade <pcpa@mandriva.com.br> 7.0.2-5mdv2008.1
+ Revision: 183783
- Actually add patches to update documentation, version (7.0.3 rc 2), and
  add two files not available in the "official" 7.0.2 tarball.

* Mon Mar 10 2008 Paulo Andrade <pcpa@mandriva.com.br> 7.0.2-4mdv2008.1
+ Revision: 183716
- Add bug fixes from mesa stable branch. Basically:
    git format-patch mesa_7_0_2..origin/mesa_7_0_branch
  but did not add patches that are not bug fixes, so this should be very
  close to mesa 7.0.3 rc2 without the documentation updates.
  This also has the side effect of "automatically" enabling fortran
  support, that has been asked by a user.

* Tue Jan 15 2008 Paulo Andrade <pcpa@mandriva.com.br> 7.0.2-3mdv2008.1
+ Revision: 153289
- Update BuildRequires.
  Needs to add xgixp and nouveau dri modules.
  Mesa 7.0.3 is expected to be released in 1 to 2 weeks, so no more changes
  to package should be done until the next release.

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request
    - stop packaging obsolete RELNOTES-[34].*

* Mon Nov 12 2007 Thierry Vignaud <tvignaud@mandriva.com> 7.0.2-2mdv2008.1
+ Revision: 108238
- patch 60: fix build
- new release
- kill patches 44, 46, 47, 100, 101, 102 & 103 (merged upstream)
- make it --short-circuit-able

* Wed Oct 24 2007 Thierry Vignaud <tvignaud@mandriva.com> 7.0.1-12mdv2008.1
+ Revision: 101784
- kill patch 6, now unneeded (added in 6.5-8mdv2007.0, sent by Sebastien savari):
  "static inline functions are broken on some architetures"
- remove patch 9 (fix compiling on x86_64) that I introduced in 6.5-8mdv2007.0
  since it's now unneeded

* Wed Oct 24 2007 Thierry Vignaud <tvignaud@mandriva.com> 7.0.1-11mdv2008.1
+ Revision: 101769
- compile with -O1 since it fixes some freeze on r200 (fd.o bug #10224)
- remove suspicious patch 7 (added by boiko in 6.5-8mdv2007.0, sent by Sebastien
  savari): "in some cases radeon may have 0 bits depth"

* Tue Oct 02 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 7.0.1-10mdv2008.0
+ Revision: 94821
- adding one more patch from claudio as a fix for #34090
  (metisse/neverball crashes on mesa). It's an obvious
  fix for a crash that happens after the previous
  workaround (we now hit what appears to be an
  unrelated bug).

* Tue Oct 02 2007 Ademar de Souza Reis Jr <ademar@mandriva.com.br> 7.0.1-9mdv2008.0
+ Revision: 94680
- adding patch from claudio to workaround bug #34090
  (metisse/neverball crash).  It just avoids the crash until
  we have the real fix, but it's a safe workaround.

* Tue Sep 18 2007 Guillaume Rousse <guillomovitch@mandriva.org> 7.0.1-8mdv2008.0
+ Revision: 89928
- rebuild

* Tue Sep 18 2007 Anssi Hannula <anssi@mandriva.org> 7.0.1-7mdv2008.0
+ Revision: 89724
- rebuild due to package loss

* Tue Sep 04 2007 Olivier Blin <oblin@mandriva.com> 7.0.1-6mdv2008.0
+ Revision: 79234
- mention OpenGL 2.1 support in description and summary (from JLP, #33115)

* Fri Aug 31 2007 Olivier Blin <oblin@mandriva.com> 7.0.1-5mdv2008.0
+ Revision: 76766
- restore gcc options, wrongly modified in commit 69003

* Sun Aug 26 2007 Anssi Hannula <anssi@mandriva.org> 7.0.1-4mdv2008.0
+ Revision: 71693
- remove GL.conf alternative, moved to x11-server-common

* Wed Aug 22 2007 Olivier Blin <oblin@mandriva.com> 7.0.1-3mdv2008.0
+ Revision: 69061
- fix glxinfo segfault with unichrome DRI (reported as upstream bug 12097)
- fix potential NULL dereference in unichrome (freedesktop bug 11879)

* Tue Aug 07 2007 Olivier Blin <oblin@mandriva.com> 7.0.1-2mdv2008.0
+ Revision: 59955
- add support for Intel 965GME/GLE (from upstream git)
- add support for Intel G33, Q33, and Q35 chipsets (from upstream git)
- add support for Intel 945GME (from upstream git)
- build with -fno-tree-vrp to fix r300 misrenderings/freezes
- re-enable parallel build

* Mon Aug 06 2007 Thierry Vignaud <tvignaud@mandriva.com> 7.0.1-1mdv2008.0
+ Revision: 59341
- new release

* Tue Jun 26 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 7.0-1mdv2008.0
+ Revision: 44280
- New upstream release: 7.0
- Redid patches linux-dri-config and radeon-0depthbits
- Removed patch: google_earth: there is a DRI runtime config option to configure
  the fallback checking.

* Thu Jun 07 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 6.5.3-2mdv2008.0
+ Revision: 36911
- rebuild for expat

* Fri May 04 2007 Colin Guthrie <cguthrie@mandriva.org> 6.5.3-1mdv2008.0
+ Revision: 22173
- Enable i915tex driver (needs new drm/kernel bits to activate)

  + Gustavo Pichorim Boiko <boiko@mandriva.com>
    - New upstream release: 6.5.3

* Tue Apr 17 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5.2-8mdv2008.0
+ Revision: 13910
- Fix some texture data corruption


* Fri Mar 30 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5.2-7mdv2007.1
+ Revision: 149942
- Fix moving DRI windows on Matrox cards

* Wed Mar 14 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5.2-6mdv2007.1
+ Revision: 143503
- check for the context to be valid before using it (probably fixes #29089)

  + Gwenole Beauchesne <gbeauchesne@mandriva.com>
    - ppc64 fixes

* Wed Jan 10 2007 Colin Guthrie <cguthrie@mandriva.org> 6.5.2-4mdv2007.1
+ Revision: 106878
- Fix demo builds on x86_64
- Fix BuildRequires
- Just use a linux-dri target for all architectures. This restores the effects of ARCH_FLAGS so this part has been reverted too.
- Build against new glproto (1.4.8)
- Add -fno-strict-aliasing to build flags as recommended by Mesa developers
- Make Mesa build system understand some extra build flags

* Tue Dec 26 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5.2-1mdv2007.1
+ Revision: 102110
- It seems parallel building is not as good as I thought it was
- new upstream version (6.5.2)
- Re-added a patch removing an incomplete extension
- new upstream version: 6.5.1
  Highlights of this version:
   * Intel i965 support
   * New OpenGL extensions added
   * New demo program: engine
   * Many fixes and improvements in drivers

* Sun Sep 17 2006 Olivier Blin <oblin@mandriva.com> 6.5-17mdv2007.0
+ Revision: 61745
- fix crash with null context (#25555)

  + Gwenole Beauchesne <gbeauchesne@mandriva.com>
    - use update-alternatives

* Wed Sep 13 2006 Olivier Blin <oblin@mandriva.com> 6.5-15mdv2007.0
+ Revision: 60951
- copy libGL files in _libdir/mesa instead of hardlink them (anyway, the stripping broke the hardlink), or else a rpm weirdness prevents libGL.so.1 from being there (#25553)

* Fri Sep 08 2006 Olivier Blin <oblin@mandriva.com> 6.5-14mdv2007.0
+ Revision: 60557
- hardlink libGL files in _libdir/mesa to prevent proprietary driver installers from removing them

* Tue Sep 05 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-13mdv2007.0
+ Revision: 59842
- Add support for DRI on Intel i965

* Thu Aug 31 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-12mdv2007.0
+ Revision: 58895
- enable tdfx for x86 and x86_64

* Fri Aug 25 2006 Olivier Blin <oblin@mandriva.com> 6.5-11mdv2007.0
+ Revision: 57986
- ensure all GART allocations are freed on context destruction (r300)
- rediff Patch44, and really apply it (GL may finally work on r300 PCIE)

* Sat Aug 19 2006 Olivier Blin <oblin@mandriva.com> 6.5-10mdv2007.0
+ Revision: 56829
- mesa-6.5-10mdv2007.0
- fix r300 on PCIE (glxinfo now works, but GL apps still make the X server crash)

* Sat Aug 12 2006 Olivier Blin <oblin@mandriva.com> 6.5-9mdv2007.0
+ Revision: 55526
- make sure mesa-source-file-generator is executable
- make sure mesa-driver-install can be executed
- bump release
- add missing glxext.c bits in old mesa-6.5-tfp-fbconfig-attribs.patch
- rename last mesa-6.5-texture-from-pixmap-fixes.patch bits as mesa-6.5-no-ARB_render_texture.patch
- move texture_from_pixmap tokens patch in mesa-6.5-texture_from_pixmap_tokens.patch
- move tfp_entrypoints patch in mesa-6.5-tfp_entrypoints.patch (and use upstream CVS diff)
- Add attrib_list to glXBindTexImageEXT
- remove attribList from glXBindTexImageEXT prototype, it breaks the extension because of incomplete implementation

* Fri Aug 04 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 6.5-8mdv2007.0
+ Revision: 48074
- remove remaining menu references
- Removed old menu entries from mesa demos.
- disable some checks making Google Earth work on r300 cards (#23854)
- Fixed a typo in previous commit
- There is no i830
- Added provides for the old mesa glu and glut devel packages (#22551)
- Many fixes for linux-dri (thanks Christiaan Welvaart)
- Enable r300 installation
- Added a more recente texture-from-pixmap-fixes patch
- Added two more patches fixing the tfp extension
- rebuild to fix compilation on x86_64
- compile mesa xdemos (glxinfo and glxgears are back).
- put a brief comment for the patches
- Adding some patches (thanks S?\195?\131?\194?\169bastien savari):
    * Fix the texture from pixmap extension implementation
    * Enable r300 support (it is experimental yet)
    * static inline functions are broken on some architetures
    * no exec stack for ELF
    * in some cases radeon may have 0 bits depth
- Added initial EGL support to the package (I left it disabled for now as it
  seems some header files are still missing)
- new upstream release: 6.5
- added a patch fixing the path where dri modules are in.
- moved old changelog to ../misc
- fixed some dependencies
- adding an updated mesa prepared to be used by the X.org 7.0

  + Per Øyvind Karlsen <pkarlsen@mandriva.com>
    - include %%{_includedir}/GL/svgamesa.h on %%{sunsparc}
    - add list of dri drivers to build on sparc
      indent
      fix path to demos in menu item

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix build (parallel build is broken)
    - better description of GLw too
    - better description of GLU and GLUT

  + Christiaan Welvaart <spturtle@mandriva.org>
    - fix build for ppc: do not build sis by using linux-dri-ppc make target
    - Fix build on ppc by adding svgamesa.h to filelist

  + Helio Chissini de Castro <helio@mandriva.com>
    - Added compile fix patch for x86_64 by Thierry Vignaud

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

* Wed Oct 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.0.2-12mdk
- merge ppc64 build fixes from older branch

* Wed Aug 17 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.0.2-11mdk
- adapt rpath patch for libtool 1.5.18

* Fri Aug 05 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.0.2-10mdk
- gcc4 fixes
- remove obsolete libGLU hack

* Thu Feb 10 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 5.0.2-9mdk
- libtool fixes

* Sat Sep 18 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 5.0.2-8mdk
- use libtool 1.4 for now

* Sat Aug 21 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 5.0.2-7mdk
- add BuildRequires: automake1.4
- remove packager tag

* Tue Aug 17 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0.2-6mdk
- Rebuild with new menu

* Fri Jun 11 2004 Laurent MONTEL <lmontel@mandrakesoft.com> 5.0.2-5mdk
- Rebuild
- Reapply patch1

* Fri Jun 04 2004 Laurent Montel <lmontel@mandrakesoft.com> 5.0.2-4mdk
- Rebuild again new gcc

* Fri Jun 04 2004 Laurent Montel <lmontel@mandrakesoft.com> 5.0.2-3mdk
- Fix build against gcc 3.4
- Add patch to nuke unpackaged files (patch from Gb)

